// Copyright (c) 2014-2017 The Dash Core developers
// Copyright (c) 2018 FXTC developers
// Copyright (c) 2018-2019 QSTEES developers
// Distributed under the MIT/X11 software license, see the accompanying
// file COPYING or http://www.opensource.org/licenses/mit-license.php.

#ifndef FXTC_MASTERNODECONFIG_H
#define FXTC_MASTERNODECONFIG_H

class CMasternodeConfig;
extern CMasternodeConfig masternodeConfig;

class CMasternodeConfig
{

public:

    class CMasternodeEntry {

    private:
        std::string alias;
        std::string ip;
        std::string privKey;
        std::string txHash;
        std::string outputIndex;
        std::string txHashBurnFund;
        std::string outputIndexBurnFund;
    public:

        CMasternodeEntry(std::string alias, std::string ip, std::string privKey, std::string txHash, std::string outputIndex,
                                std::string txHashBurnFund, std::string outputIndexBurnFund) {
            this->alias = alias;
            this->ip = ip;
            this->privKey = privKey;
            this->txHash = txHash;
            this->outputIndex = outputIndex;
            this->txHashBurnFund = txHashBurnFund;
            this->outputIndexBurnFund = outputIndexBurnFund;
        }

        const std::string& getAlias() const {
            return alias;
        }

        void setAlias(const std::string& alias) {
            this->alias = alias;
        }

        const std::string& getOutputIndex() const {
            return outputIndex;
        }

        void setOutputIndex(const std::string& outputIndex) {
            this->outputIndex = outputIndex;
        }

        const std::string& getPrivKey() const {
            return privKey;
        }

        void setPrivKey(const std::string& privKey) {
            this->privKey = privKey;
        }

        const std::string& getTxHash() const {
            return txHash;
        }

        void setTxHash(const std::string& txHash) {
            this->txHash = txHash;
        }

        const std::string& getTxHashBurnFund() const {
            return txHashBurnFund;
        }

        void setTxHashBurnFund(const std::string& txHashBurnFund) {
            this->txHashBurnFund = txHashBurnFund;
        }

        const std::string& getOutputIndexBurnFund() const {
            return outputIndexBurnFund;
        }

        void setOutputIndexBurnFund(const std::string& outputIndexBurnFund) {
            this->outputIndexBurnFund = outputIndexBurnFund;
        }

        const std::string& getIp() const {
            return ip;
        }

        void setIp(const std::string& ip) {
            this->ip = ip;
        }
    };

    CMasternodeConfig() {
        entries = std::vector<CMasternodeEntry>();
    }

    void clear();
    bool read(std::string& strErr);
    void add(std::string alias, std::string ip, std::string privKey, std::string txHash, std::string outputIndex, 
            std::string txHashBurnFund, std::string outputIndexBurnFund);

    std::vector<CMasternodeEntry>& getEntries() {
        return entries;
    }

    int getCount() {
        return (int)entries.size();
    }

private:
    std::vector<CMasternodeEntry> entries;


};

#endif // FXTC_MASTERNODECONFIG_H
